server/api/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import patterns, url

urlpatterns = patterns(
    'api.views',


    url(r'^transactions/$', 'transactions_list'),

    url(r'^transactions/(?P<reference>.*)/logs/$', 'transactions_show_logs'),
    url(r'^transactions/(?P<reference>.*)/$', 'transactions_show'),

)

server/app/urls.py
from django.conf.urls import patterns, include, url
from django.conf import settings

# Uncomment the next two lines to enable the admin:
# from django.contrib import admin
# admin.autodiscover()

urlpatterns = patterns(
    '',

    (r'^users/login$', 'tequila.login'),
    (r'^users/logout$', 'django.contrib.auth.views.logout', {'next_page': '/'}),

    url(r'', include('main.urls')),
    url(r'^api/', include('api.urls')),
    url(r'^users/', include('users.urls')),
    url(r'^export/', include('export.urls')),
    url(r'^configs/', include('configs.urls')),
    url(r'^paiements/', include('paiements.urls')),
    url(r'^comparator/', include('comparator.urls')),

    (r'^' + settings.MEDIA_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.MEDIA_ROOT}),  # In prod, use apache !
    (r'^' + settings.STATIC_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT}),  # In prod, use apache !
)

server/export/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import patterns, url

urlpatterns = patterns(
    'export.views',


    url(r'^$', 'home'),

    url(r'^summary$', 'summary'),


)

server/configs/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils.html import escape
from django.utils.translation import ugettext_lazy as _

import uuid
import datetime
import hashlib
import random


class Config(models.Model):
    """Represent a website configuration"""

    name = models.CharField(max_length=255)

    active = models.BooleanField(default=True)
    admin_enable = models.BooleanField(default=True)

    test_mode = models.BooleanField(default=True)

    url_ipn = models.URLField()
    url_back_ok = models.URLField()
    url_back_err = models.URLField()

    key_request = models.CharField(max_length=255)
    key_ipn = models.CharField(max_length=255)
    key_api = models.CharField(max_length=255)

    allowed_users = models.ManyToManyField(User, blank=True)

    group = models.CharField(max_length=255, help_text=_('To group configs in summary'), blank=True, null=True)

    def __unicode__(self):
        bonus = u''

        if self.test_mode:
            bonus += u'<i class="fa fa-flask"></i>'

        if not self.active or not self.admin_enable:
            bonus += u'<i class="glyphicon glyphicon-ban-circle"></i>'

        if bonus:
            bonus = u' (' + bonus + u')'

        return escape(self.name) + bonus

    def build_user_list(self):
        """Return a list of user in text format"""
        return u','.join([user.username for user in self.allowed_users.order_by('username')])

    def generate_diff(self, other):
        """Generate diff from this objet an another one (for logs)"""
        retour = u'\n\n'

        for (prop, prop_name) in (('name', 'Name'), ('active', 'Active'), ('admin_enable', 'Admin enable'), ('test_mode', 'Test mode'), ('url_ipn', 'URL Ipn'), ('url_back_ok', 'Return URL for success'), ('url_back_err', 'Return URL for error'), ('group', 'Group')):
            if not other.pk or getattr(self, prop) != getattr(other, prop):
                retour += unicode(prop_name) + u'=' + unicode(getattr(self, prop))

                if other.pk:
                    retour += _(u' (was ') + unicode(getattr(other, prop)) + u')'

                retour += u'\n'

        retour += _(u'User list: ') + self.build_user_list()
        return retour

    def is_user_allowed(self, user):
        """Return true is a user is allowed to display / edit the config"""

        if user.is_superuser:
            return True
        elif not self.pk:
            return user.is_staff  # Only staff can create configs
        else:
            return user in list(self.allowed_users.all())

    def gen_key(self):
        """Return a random key suitable for keys of the model"""

        h = hashlib.sha512()

        for i in range(2):
            h.update(str(random.SystemRandom().random()))
            h.update(str(uuid.uuid4()))
            h.update(str(datetime.datetime.now()))
            h.update(str(self.pk))
            h.update(self.name)

        return h.hexdigest()

    def gen_key_api(self):
        """Generate a new key for api"""
        self.key_api = self.gen_key()

    def gen_key_ipn(self):
        """Generate a new key for ipn"""
        self.key_ipn = self.gen_key()

    def gen_key_request(self):
        """Generate a new key for requests"""
        self.key_request = self.gen_key()

    def save(self, *args, **kwargs):
        """Overide the save request to check if all keys have been generated"""

        if not self.key_api:
            self.gen_key_api()

        if not self.key_ipn:
            self.gen_key_ipn()

        if not self.key_request:
            self.gen_key_request()

        super(Config, self).save(*args, **kwargs)


class ConfigLogs(models.Model):

    config = models.ForeignKey(Config)
    user = models.ForeignKey(User)
    when = models.DateTimeField(auto_now_add=True)
    text = models.TextField()

server/export/models.py
from django.db import models

# Create your models here.

server/export/forms.py
from django import forms
from django.utils.translation import ugettext_lazy as _


from configs.models import Config


class ConfigModelChoiceField(forms.ModelChoiceField):
    def label_from_instance(self, obj):
        return obj.name + (' (Test)' if obj.test_mode else '')


class ExportForm(forms.Form):

    FILE_TYPE_CHOICES = (
        ('json', _('JSON')),
        ('xml', _('XML')),
        ('csv', _('CSV (Without logs)')),
    )

    RANGE_CHOICES = [
        ('thismonth', _('This month')),
        ('previousmonth', _('The previous month')),
        ('sincemonth', _('Since a month')),
        ('thisyear', _('This year')),
        ('sinceyear', _('Since a year')),
        ('custom', _('Custom')),
    ]

    all_config = forms.BooleanField(help_text=_('Export transactions from all configs'), required=False)
    only_good = forms.BooleanField(help_text=_('Export only good transactions'), required=False)
    config = ConfigModelChoiceField(queryset=None, required=False)

    file_type = forms.ChoiceField(choices=FILE_TYPE_CHOICES)

    range = forms.ChoiceField(choices=RANGE_CHOICES)

    custom_start = forms.DateTimeField(required=False)
    custom_end = forms.DateTimeField(required=False)

    def __init__(self, user, *args, **kwargs):
        super(ExportForm, self).__init__(*args, **kwargs)

        if not user.is_superuser:
            del self.fields['all_config']
            self.fields['config'].queryset = Config.objects.filter(allowed_users=user).order_by('name').all()
        else:
            self.fields['config'].queryset = Config.objects.order_by('name').all()

    def clean(self):
        cleaned_data = super(ExportForm, self).clean()

        all_config = cleaned_data.get('all_config', False)
        config = cleaned_data.get('config', None)

        if not all_config and not config:
            raise forms.ValidationError(_('Please select a config'))

        range = cleaned_data.get('range')
        custom_start = cleaned_data.get('custom_start')
        custom_end = cleaned_data.get('custom_end')

        if range == 'custom' and (not custom_start or not custom_end):
            raise forms.ValidationError(_('Please select start and end date'))

        return cleaned_data


class SummaryForm(forms.Form):

    RANGE_CHOICES = [
        ('thismonth', _('This month')),
        ('previousmonth', _('The previous month')),
        ('sincemonth', _('Since a month')),
        ('thisyear', _('This year')),
        ('sinceyear', _('Since a year')),
        ('custom', _('Custom')),
    ]

    TRANSACTION_LIST = [
        ('no', _('No')),
        ('grouped', _('Grouped')),
        ('list', _('Yes'))
    ]

    include_test = forms.BooleanField(help_text=_('Export transactions from all config'), required=False)

    transactions = forms.ChoiceField(choices=TRANSACTION_LIST, help_text=_('Include transactions?'))

    range = forms.ChoiceField(choices=RANGE_CHOICES)

    custom_start = forms.DateTimeField(required=False)
    custom_end = forms.DateTimeField(required=False)

    def clean(self):
        cleaned_data = super(SummaryForm, self).clean()

        range = cleaned_data.get('range')
        custom_start = cleaned_data.get('custom_start')
        custom_end = cleaned_data.get('custom_end')

        if range == 'custom' and (not custom_start or not custom_end):
            raise forms.ValidationError(_('Please select start and end date'))

        return cleaned_data

server/export/templates/export/home.html
{% extends "base.html" %}
{% load i18n %}
{% load bootstrap3 %}

{% block title %}{{block.super}} :: {% trans "Export data" %}{% endblock %}

{% block content %}

<script type="text/javascript">$('#nav-export').addClass('active');</script>

<h2>{% trans "Export of data" %}</h2>

<ol class="breadcrumb">
  <li><a href="{% url 'main.views.home' %}"><i class="fa fa-home"></i> {% trans "Home" %}</a></li>

  <li class="active"><i class="fa fa-truck"></i> {% trans "Export form" %}</li>

</ol>

<div class="row-fluid">
    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">{% trans "Export parameters" %}</h3>
        </div>
        <div class="panel-body">

            <form action="" method="POST">
                {% csrf_token %}

                {% bootstrap_form form %}

                <div class="row-fluid box-section" style="text-align: right;">
                    <input type="submit" class="btn btn-primary" value="{% trans "Export" %}">
                </div>

            </form>
        </div>
    </div>

</div>

<script type="text/javascript">
  $('#id_config, #id_file_type, #id_range').select2();

  $(function () {
        $('#id_custom_start, #id_custom_end').datetimepicker({language:'fr'});
    });

</script>


{% endblock %}

server/export/templates/export/summary.html
{% extends "base.html" %}
{% load i18n %}
{% load bootstrap3 %}

{% block title %}{{block.super}} :: {% trans "Summary" %}{% endblock %}

{% block content %}

<script type="text/javascript">$('#nav-summary').addClass('active');</script>

<h2>{% trans "Export of data" %}</h2>

<ol class="breadcrumb">
  <li><a href="{% url 'main.views.home' %}"><i class="fa fa-home"></i> {% trans "Home" %}</a></li>

  <li class="active"><i class="fa fa-ticket"></i> {% trans "Summary form" %}</li>

</ol>

<div class="row-fluid">
    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">{% trans "Summary parameters" %}</h3>
        </div>
        <div class="panel-body">

            <form action="" method="POST">
                {% csrf_token %}

                {% bootstrap_form form %}

                <div class="row-fluid box-section" style="text-align: right;">
                    <input type="submit" class="btn btn-primary" value="{% trans "Export" %}">
                </div>

            </form>
        </div>
    </div>

</div>

<script type="text/javascript">
  $('#id_range, #id_transactions').select2();

    $(function () {
        $('#id_custom_start, #id_custom_end').datetimepicker({language:'fr'});
    });
</script>


{% endblock %}

server/export/templates/export/summary_pdf.html
{% load i18n %}<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
        <title>PolyBanking - {% blocktrans with start_date=start_date|date:"r" end_date=end_date|date:"r" %}Summary from {{start_date}} to {{end_date}}{% endblocktrans %}</title>
        <style type="text/css">
            @page {
                /*size: {{ pagesize }};*/
                margin: 1cm;
                @frame footer {
                    -pdf-frame-content: footerContent;
                    bottom: 0cm;
                    margin-left: 9cm;
                    margin-right: 9cm;
                    height: 2cm;
                }
            }

            table tr {
                border: 1px black solid;
                padding: 3px;
            }
        </style>
    </head>
    <body>
        <h1>PolyBanking - {% blocktrans with start_date=start_date|date:"r" end_date=end_date|date:"r" %}Summary from {{start_date}} to {{end_date}}{% endblocktrans %}</h1>

        <br />
        <b>{% trans "Only transactions with status=9, Payement requested are displayed and used for computations" %}</b>
        <br />

        <div>
            {% for group_name, group_data in data.items %}
                <h2>{{group_name}}</h2>

                <table>
                    <thead>
                        <tr>
                            <th>{% trans "Config" %}</th>
                            <th>{% trans "From" %}</th>
                            <th>{% trans "To" %}</th>
                            <th>{% trans "Total" %}</th>
                        </tr>
                    </thead>

                    <tbody>

                        {% for configs_data in group_data.0 %}

                            {% for config_data in configs_data %}

                                {% if forloop.first %}
                                    <tr>
                                        <td>{{config_data.3.name}} {% if config_data.3.test_mode %}{% trans "(Test mode !)" %}{% endif %}</td>
                                        <td>{{config_data.0|date:"r"}}</td>
                                        <td>{{config_data.1|date:"r"}}</td>
                                        <td>{{config_data.2|floatformat:"2"}} CHF</td>
                                    </tr>
                                {% else %}


                                    {% if forloop.last %}
                                        <tr>
                                            <td></td>
                                            <td></td>
                                            <td></td>
                                            <td><b>{{config_data|floatformat:"2"}} CHF</b></td>
                                        </tr>
                                    {% else %}


                                        <tr>
                                            <td></td>
                                            <td>{{config_data.0|date:"r"}}</td>
                                            <td>{{config_data.1|date:"r"}}</td>
                                            <td>{{config_data.2|floatformat:"2"}} CHF</td>
                                        </tr>

                                    {% endif %}


                                {% endif %}

                            {% endfor %}


                        {% endfor %}

                        <tr style="border: none;"><td></td><td></td><td></td><td>&nbsp;</td></tr>

                        <tr><td><b>{% trans "Total" %}</b></td><td>{{start_date|date:"r"}}</td><td>{{end_date|date:"r"}}</td><td><b><u>{{group_data.1|floatformat:"2"}} CHF</u></b></td></tr>


                    </tbody>
                </table>

            {% endfor %}
        </div>

        {% if transactions %}
            
            {% for group_name, transactions_data in transactions.items %}
                <pdf:nextpage />    
                <h2>{{group_name}}</h2>

                <table>
                    <thead>
                        <tr>
                            <th>{% trans "Postfinance ID" %}</th>
                            <th>{% trans "Internal ID" %}</th>
                            <th>{% trans "Config/Group" %}</th>
                            <th>{% trans "Date" %}</th>
                            <th>{% trans "Total" %}</th>
                        </tr>
                    </thead>

                    <tbody>

                        {% for t in transactions_data %}

                            <tr>
                                <td>{{t.postfinance_id}}</td>
                                <td>{{t.reference}} ({{t.pk}})</td>
                                <td>{{t.config.name}}/{{t.config.group|default:""}}</td>
                                <td>{{t.creation_date|date}} {{t.creation_date|time}}</td>
                                <td>{{t.amount_chf|floatformat:"2"}} CHF</td>
                            </tr>

                        {% endfor %}

                    </tbody>

                </table>

            {% endfor %}




        {% endif %}

        <div id="footerContent">
            
                Page <pdf:pagenumber /> - PolyBanking - {% blocktrans with start_date=start_date|date:"r" end_date=end_date|date:"r" %}Summary from {{start_date}} to {{end_date}}{% endblocktrans %}
                <br />
            
            <b>{% trans "Only transactions with status=9, Payement requested are displayed and used for computations" %}</b>
        </div>
    </body>
</html>